SystemOrganization addCategory: #MareaUtilities!

Object subclass: #CodeStats
	instanceVariableNames: 'packagePatterns'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'MareaUtilities'!

!CodeStats commentStamp: '<historical>' prior: 0!
WebCodeStats counts classes, methods, avg methods per class, avg lines per method, nr of tests, and many more. Used to measure code statistics in web frameworks, but can also be used more generally. Just fill the appropriate package patterns in your own setup method.

Example:
	WebCodeStats default 
		setAidaCodeStats;
		printReport.
!

!CodeStats classSide methodsFor: 'accessing' stamp: 'janko 11/12/2010 16:41'!
default
	Default ifNil: [Default := self new].
	^Default! !

!CodeStats classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 12:02'!
ghostStats
	CodeStats default setGhostCodeStats; printReport. ! !

!CodeStats methodsFor: 'averages' stamp: 'janko 11/12/2010 16:41'!
avgLinesPerMethod
	"WebCodeStats default avgLinesPerMethod"
	^(self linesOfCode/self nrOfMethods)
		asScaledDecimal: 1! !

!CodeStats methodsFor: 'averages' stamp: 'janko 11/12/2010 16:42'!
avgMethodsPerClass
	"WebCodeStats default avgMethodsPerClass"
	^(self nrOfMethods/self nrOfClasses)
		asScaledDecimal: 1! !

!CodeStats methodsFor: 'distributions' stamp: 'janko 11/15/2010 09:52'!
classInheritanceDepth
	"nr of classes by its class inheritance depth, 0 = Object"
	"WebCodeStats default classInheritanceDepth"
	| dict |
	dict := Dictionary new.
	self classes do: [:class || depth |
		depth := class allSuperclasses size - 1. "ProtoObject not counted"
		dict at: depth put: (dict at: depth ifAbsentPut: [0]) + 1].
	0 to: dict keys max do: [:nrOfMethods |   "populate empty slots with 0"
		dict at: nrOfMethods ifAbsentPut: [0] ].
	^dict! !

!CodeStats methodsFor: 'accessing' stamp: 'Janko 11/12/2010 11:05'!
classes
	^self packages
		inject: OrderedCollection new
		into: [:coll :package | coll addAll: package classes; yourself]! !

!CodeStats methodsFor: 'distributions' stamp: 'janko 11/15/2010 09:38'!
classesPerMethods
	"returns a dictionary of number of classes per nr of methods in class"
	"example: (dict at: 5) returns nr of classes having 5 methods"
	"WebCodeStats default classesPerMethods"
	| dict |
	dict := Dictionary new.
	self classes do: [:class || methods |
		methods := class methods size.
		dict at: methods put: (dict at: methods ifAbsentPut: [0]) + 1].
	0 to: dict keys max do: [:nrOfMethods |   "populate empty slots with 0"
		dict at: nrOfMethods ifAbsentPut: [0] ].
	^dict! !

!CodeStats methodsFor: 'accessing' stamp: 'janko 11/15/2010 09:44'!
commentedClasses
	"WebCodeStats default commentedClasses"
	^self classes select: [:class | class hasComment]! !

!CodeStats methodsFor: 'accessing' stamp: 'janko 11/13/2010 21:08'!
commentedMethods
	"WebCodeStats default commentedMethods"
	^self methods select: [:method |
		method compiledMethod comment notNil]! !

!CodeStats methodsFor: 'counting' stamp: 'janko 11/12/2010 16:42'!
linesOfCode
	"Includes comments, but excludes empty lines"
	"WebCodeStats default linesOfCode"
	^self packages
		inject: 0
		into: [:sum :package | sum + package linesOfCode]! !

!CodeStats methodsFor: 'accessing' stamp: 'Janko 11/12/2010 11:12'!
methods
	^self packages
		inject: OrderedCollection new
		into: [:col :package | col addAll: package methods; yourself]! !

!CodeStats methodsFor: 'distributions' stamp: 'janko 11/15/2010 09:39'!
methodsPerLines
	"returns a dictionary of number of methods per nr of lines"
	"example: (dict at: 5) returns nr of methods having 5 lines"
	"WebCodeStats default methodsPerLines"
	| dict |
	dict := Dictionary new.
	self methods do: [:method || lines |
		lines := method compiledMethod linesOfCode.
		dict at: lines put: (dict at: lines ifAbsentPut: [0]) + 1].
	0 to: dict keys max do: [:nrOfLines |   "populate empty slots with 0"
		dict at: nrOfLines ifAbsentPut: [0] ].
	^dict! !

!CodeStats methodsFor: 'distributions' stamp: 'janko 11/12/2010 16:43'!
methodsPerLinesTreshold: treshold
	"returns only distribution long until above treshold, to avoid counting few methods but big methods on 
	right side of distribution"
	"WebCodeStats default methodsPerLinesTreshold: 2"
	| dict collection tresholdLines |
	dict := self methodsPerLines.
	collection := dict associations asSortedCollection: [:a :b | a key < b key].
	tresholdLines := (collection size to: 1 by: -1) 
		detect:  [:lines | (collection at: lines) value > treshold] ifNone: [dict size].
	 ^Dictionary newFrom: 
		(collection copyFrom: 1 to: tresholdLines).
	
! !

!CodeStats methodsFor: 'counting' stamp: 'janko 11/12/2010 16:42'!
nrOfCategories
	"WebCodeStats default nrOfCategories"
	^self packages
		inject: 0
		into: [:sum :package | sum + package systemCategories size]! !

!CodeStats methodsFor: 'counting' stamp: 'jm 11/12/2010 20:15'!
nrOfClasses
	"WebCodeStats default nrOfClasses"
	^self classes size! !

!CodeStats methodsFor: 'counting' stamp: 'janko 11/12/2010 16:42'!
nrOfCommentedMethods
	"WebCodeStats default nrOfCommentMethods"
	^(self methods select: [:method | method isCommented]) size
	! !

!CodeStats methodsFor: 'counting' stamp: 'jm 11/12/2010 20:14'!
nrOfMethods
	"WebCodeStats default nrOfMethods"
	^self methods size! !

!CodeStats methodsFor: 'counting' stamp: 'jm 11/12/2010 20:21'!
nrOfTestMethods
	"WebCodeStats default nrOfTestMethods"
	^self testMethods size! !

!CodeStats methodsFor: 'private' stamp: 'janko 11/12/2010 16:38'!
packagePatterns
	^packagePatterns ! !

!CodeStats methodsFor: 'private' stamp: 'Janko 11/12/2010 10:44'!
packages
	"Packages included in stats, as defined in #packagePatterns"
	"WebCodeStats new packages"
	| packageInfos patterns |
	packageInfos := (MCWorkingCopy registry collect: #packageInfo) values.
	^packageInfos select: [:each | 
		self packagePatterns anySatisfy: [:pattern | pattern match: each packageName]]! !

!CodeStats methodsFor: 'counting' stamp: 'jm 11/13/2010 21:36'!
percentOfCommentedClasses
	"WebCodeStats default percentOfCommentedClasses"
	 ^((self commentedClasses size / self nrOfClasses ) * 100) rounded
	
	! !

!CodeStats methodsFor: 'counting' stamp: 'Janko 11/13/2010 21:22'!
percentOfCommentedMethods
	"WebCodeStats default percentOfCommentedMethods"
	 ^((self commentedMethods size / self nrOfMethods ) * 100) rounded
	
	! !

!CodeStats methodsFor: 'reporting' stamp: 'janko 11/12/2010 16:43'!
printClassesDistribution
	"in CSV format for easier incusion to spreadsheets"
	"WebCodeStats default printClassesDistribution"
	| sorted stream |
	sorted := self classesPerMethods associations asSortedCollection: [:a :b | a key < b key].
	stream := WriteStream on: String new.
	sorted do: [:assoc | stream 
		nextPutAll: assoc key printString, '; ';
		nextPutAll: assoc value printString;
		nextPut: Character cr].
	^stream contents! !

!CodeStats methodsFor: 'reporting' stamp: 'janko 11/15/2010 09:54'!
printInheritanceDistribution
	"in CSV format for easier incusion to spreadsheets"
	"WebCodeStats default printInheritanceDistribution"
	| sorted stream |
	sorted := self classInheritanceDepth associations asSortedCollection: [:a :b | a key < b key].
	stream := WriteStream on: String new.
	sorted do: [:assoc | stream 
		nextPutAll: assoc key printString, '; ';
		nextPutAll: assoc value printString;
		nextPut: Character cr].
	^stream contents! !

!CodeStats methodsFor: 'reporting' stamp: 'janko 11/12/2010 16:43'!
printMethodsDistribution
	"in CSV format for easier incusion to spreadsheets"
	"WebCodeStats default printMethodsDistribution"
	| sorted stream |
	sorted := self methodsPerLines associations asSortedCollection: [:a :b | a key < b key].
	stream := WriteStream on: String new.
	sorted do: [:assoc | stream 
		nextPutAll: assoc key printString, '; ';
		nextPutAll: assoc value printString;
		nextPut: Character cr].
	^stream contents! !

!CodeStats methodsFor: 'reporting' stamp: 'jm 11/13/2010 21:37'!
printReport
	"WebCodeStats default printReport"
	^'Code stats
	
	for: ', self packagePatterns printString, '
	
	Nr of packages: ', self packages size printString, '
	Nr of categories ', self nrOfCategories printString, '
	Nr of classes: ', self nrOfClasses printString, '
	Nr of methods: ', self nrOfMethods printString, '
	lines of code: ', self linesOfCode printString, '
	Avg methods/class: ', self avgMethodsPerClass printString, '
	Avg lines/method: ', self avgLinesPerMethod printString, '
	
	Nr of test methods: ', self nrOfTestMethods printString, '
	% of commented methods: ', self percentOfCommentedMethods printString, '
	% of commented classes: ', self percentOfCommentedClasses printString
! !

!CodeStats methodsFor: 'setup' stamp: 'janko 11/12/2010 16:44'!
setAidaCodeStats
	"WebCodeStats default setAidaCodeStats"
	packagePatterns := #('Aida*')

! !

!CodeStats methodsFor: 'setup' stamp: 'MarianoMartinezPeck 4/21/2011 11:46'!
setGhostCodeStats
	"WebCodeStats default setAidaCodeStats"
	packagePatterns := #('GhostProxies')

! !

!CodeStats methodsFor: 'setup' stamp: 'janko 11/12/2010 16:44'!
setIliadCodeStats
	"WebCodeStats default setIliadCodeStats"
	packagePatterns := #('Iliad*')

! !

!CodeStats methodsFor: 'setup' stamp: 'janko 11/12/2010 16:45'!
setSeasideCodeStats
	"WebCodeStats default setSeasideCodeStats"
	packagePatterns := #('Seaside*' 'Comet*' 'jQuery*' 'Scriptaculous*' 'Prototype*' 
		'Javascript*' 'RSS*').

! !

!CodeStats methodsFor: 'accessing' stamp: 'jm 11/12/2010 20:20'!
testMethods
	"WebCodeStats default testMethods"
	^self methods select: [:method |
		(method actualClass inheritsFrom: TestCase)
			and: ['test*' match: method selector asString] ]! !

Object subclass: #ObjectMeasures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaUtilities'!

!ObjectMeasures classSide methodsFor: 'as yet unclassified' stamp: 'asda 1/12/2011 16:02'!
measureHowMuchMemoryWinReplacingEachObjectByProxy

| totalAmountOfObjects totalObjectsSize totalDifference proxySize |
totalAmountOfObjects := 0.
totalObjectsSize := 0. 
totalDifference := 0.
"We assume a Proxy instance that has one inst var which is a SmallInteger"
proxySize := 12.
3 timesRepeat: [Smalltalk garbageCollect]. 
SystemNavigation default allObjectsDo: [ :each |
	totalAmountOfObjects := totalAmountOfObjects + 1.
	totalObjectsSize := totalObjectsSize + each sizeInMemory.
	totalDifference := totalDifference + each sizeInMemory - proxySize.
	]. 
Transcript show: 'Total amount of obects: ', totalAmountOfObjects asString; cr.
Transcript show: 'Average size of objects:: ', (totalObjectsSize / totalAmountOfObjects) asFloat asString; cr.
Transcript show: 'Total objects size: ', totalObjectsSize asString; cr.
Transcript show: 'Total objects size as proxies ', (totalAmountOfObjects * 12) asString; cr.
Transcript show: 'Total difference: ', totalDifference asString; cr.
Transcript show: 'The difference represents a ', (totalDifference * 100 / totalObjectsSize) asFloat asString, ' % of the total memory'; cr.
 


! !
